
class _Node():
  def __init__(self, key, value, next):
    self.key = key
    self.value = value
    self.next = next

def _hash(key):
  return (key) % 100

class dict():
  def __init__(self):
    self._data = [ None ] * 100

  def __repr__(self):
    s = ""
    for i in range(100):
      s += "%02d: " % i
      p = self._data[i]
      while p is not None:
        s += str(p.key) + " "
        p = p.next
      s += "\n"
    return s

  def _findnode(self, key):
    i = _hash(key)
    p = self._data[i]
    while p is not None:
      if p.key == key:
        return p
      p = p.next
    return None

  def __contains__(self, key):
    return self._findnode(key) is not None

  def __setitem__(self, key, value):
    p = self._findnode(key)
    if p:
      p.value = value
    else:
      h = _hash(key)
      self._data[h] = _Node(key, value, self._data[h])

  def __getitem__(self, key):
    p = self._findnode(key)
    if p:
      return p.value
    else:
      raise ValueError(key)
